
;0.5us pre trigger, 15 machine cycles
trc8_05us_pr: rcall trc_prep
trc8_05us_wt_p2: mov r3,r1
	in r0,PINA
	and r3,r0
	cpse r3,r2
	rjmp trc8_05us_wt_p2
tlpr05us: in r0,PINA	;1
	st Y+,r0			;2
	rcall return		;3+4
	nop					;1
	sbiw r25:r24,1		;2
	brne tlpr05us		;2
;						 15
	rjmp trc_end

return: ret

;0.5us pre trigger, 15 machine cycles
trc16_05us_pr: rcall trc_prep
trc16_05us_wt_p2: mov r3,r1
	in r0,PINA
	and r3,r0
	cpse r3,r2
	rjmp trc16_05us_wt_p2
tlpra05us: in r0,PINA	;1
	in r3,PINC			;1
	st Y+,r0			;2
	st Y+,r3			;2
	rjmp PC+1			;2
	rjmp PC+1			;2
	nop					;1
	sbiw r25:r24,1		;2
	brne tlpra05us		;2
;						 15
	rjmp trc_end

;1us pre trigger, 30 machine cycles
trc8_1us_pr: 	ldi r17,7
trc8_1us_prc: rcall trc_prep
trc8_1us_wt_p2: mov r3,r1
	in r0,PINA
	and r3,r0
	cpse r3,r2
	rjmp trc8_1us_wt_p2
tlpr1us: in r0,PINA		;1
	st Y+,r0			;2
	mov r16,r17			;1
tlpr1us_dly: dec r16	;1
	brne tlpr1us_dly	;2/1=20
	rjmp PC+1			;2
	sbiw r25:r24,1		;2
	brne tlpr1us		;2
;						 30
	rjmp trc_end

;1us pre trigger, 30 machine cycles
trc16_1us_pr: ldi r17,6
trc16_1us_prc: rcall trc_prep
trc16_1us_wt_p2: mov r3,r1
	in r0,PINA
	and r3,r0
	cpse r3,r2
	rjmp trc16_1us_wt_p2
tlpra1us: in r0,PINA	;1
	in r3,PINC			;1
	st Y+,r0			;2
	st Y+,r3			;2
	mov r16,r17			;1
tlpra1us_dly: dec r16	;1
	brne tlpra1us_dly	;2/1=17
	rjmp PC+1			;2
	sbiw r25:r24,1		;2
	brne tlpra1us		;2
;						 30
	rjmp trc_end

;2us pre trigger, 60 machine cycles
trc8_2us_pr: ldi r17,17
	rjmp trc8_1us_prc

trc16_2us_pr: ldi r17,16
	rjmp trc16_1us_prc

;5us pre trigger, 150 machine cycles
trc8_5us_pr: ldi r17,47
	rjmp trc8_1us_prc

trc16_5us_pr: ldi r17,46
	rjmp trc16_1us_prc

;10us pre trigger, 300 machine cycles
trc8_10us_pr: ldi r17,97
	rjmp trc8_1us_prc

trc16_10us_pr: ldi r17,96
	rjmp trc16_1us_prc

;20us pre trigger, 600 machine cycles
trc8_20us_pr: ldi r17,197
	rjmp trc8_1us_prc

trc16_20us_pr: ldi r17,196
	rjmp trc16_1us_prc

;50us pre trigger, 1500 machine cycles
trc8_50us_pr: ldi r16,LOW(373)
	ldi r17,HIGH(373)
trc8_50us_prc: rcall trc_prep
trc8_50us_wt_p2: mov r3,r1
	in r0,PINA
	and r3,r0
	cpse r3,r2
	rjmp trc8_50us_wt_p2
tlpr50us: in r0,PINA	;1
	st Y+,r0			;2
	mov XL,r16			;1
	mov XH,r17			;1
tlpr50us_dly: sbiw XH:XL,1 ;2
	brne tlpr50us_dly	;2/1
	sbiw r25:r24,1		;2
	brne tlpr50us		;2
;						 1500
	rjmp trc_end

;50us pre trigger, 1500 machine cycles
trc16_50us_pr: ldi r16,LOW(372)
	ldi r17,HIGH(372)
trc16_50us_prc: rcall trc_prep
trc16_50us_wt_p2: mov r3,r1
	in r0,PINA
	and r3,r0
	cpse r3,r2
	rjmp trc16_50us_wt_p2
tlpra50us: in r0,PINA	;1
	in r3,PINC			;1
	st Y+,r0			;2
	st Y+,r3			;2
	nop					;1
	mov XL,r16			;1
	mov XH,r17			;1
tlpra50us_dly: sbiw XH:XL,1 ;2
	brne tlpra50us_dly	;2/1
	sbiw r25:r24,1		;2
	brne tlpra50us		;2
;						 1500
	rjmp trc_end

;100us pre trigger, 3000 machine cycles
trc8_100us_pr: ldi r16,LOW(748)
	ldi r17,HIGH(748)
	rjmp trc8_50us_prc

trc16_100us_pr: ldi r16,LOW(747)
	ldi r17,HIGH(747)
	rjmp trc16_50us_prc

;200us pre trigger, 6000 machine cycles
trc8_200us_pr: ldi r16,LOW(1498)
	ldi r17,HIGH(1498)
	rjmp trc8_50us_prc

trc16_200us_pr: ldi r16,LOW(1497)
	ldi r17,HIGH(1497)
	rjmp trc16_50us_prc

;500us pre trigger, 15000 machine cycles
trc8_500us_pr: ldi r16,LOW(3748)
	ldi r17,HIGH(3748)
	rjmp trc8_50us_prc

trc16_500us_pr: ldi r16,LOW(3747)
	ldi r17,HIGH(3747)
	rjmp trc16_50us_prc

;1ms pre trigger, 30000 machine cycles
trc8_1ms_pr: ldi r16,LOW(7498)
	ldi r17,HIGH(7498)
	rjmp trc8_50us_prc

trc16_1ms_pr: ldi r16,LOW(7497)
	ldi r17,HIGH(7497)
	rjmp trc16_50us_prc

;2ms pre trigger, 60000 machine cycles
trc8_2ms_pr: ldi r16,LOW(14998)
	ldi r17,HIGH(14998)
	rjmp trc8_50us_prc

trc16_2ms_pr: ldi r16,LOW(14997)
	ldi r17,HIGH(14997)
	rjmp trc16_50us_prc

;5ms pre trigger, 150000 machine cycles
trc8_5ms_pr: ldi r16,LOW(37498)
	ldi r17,HIGH(37498)
	rjmp trc8_50us_prc

trc16_5ms_pr: ldi r16,LOW(37497)
	ldi r17,HIGH(37497)
	rjmp trc16_50us_prc

;10ms pre trigger, 300000 machine cycles
trc8_10ms_pr: ldi r16,LOW(999)
	ldi r17,HIGH(999)
trc8_10ms_prc: rcall trc_prep
trc8_10ms_wt_p2: mov r3,r1
	in r0,PINA
	and r3,r0
	cpse r3,r2
	rjmp trc8_10ms_wt_p2
tlpr10ms: in r0,PINA	;1
	st Y+,r0			;2
	mov XL,r16			;1
	mov XH,r17			;1
tlpr10ms_dly:
	ldi r18,98			;1
tlpr10ms_dly1: dec r18	;1
	brne tlpr10ms_dly1	;2/1
	rjmp PC+1			;2
	sbiw XH:XL,1		;2
	brne tlpr10ms_dly	;2/1
	ldi r18,97			;1
tlpr10ms_dly2: dec r18	;1
	brne tlpr10ms_dly2	;2/1
	nop
	sbiw r25:r24,1		;2
	brne tlpr10ms		;2
;						 300000
	rjmp trc_end

;10ms pre trigger, 300000 machine cycles
trc16_10ms_pr: ldi r16,LOW(999)
	ldi r17,HIGH(999)
trc16_10ms_prc: rcall trc_prep
trc16_10ms_wt_p2: mov r3,r1
	in r0,PINA
	and r3,r0
	cpse r3,r2
	rjmp trc16_10ms_wt_p2
tlpra10ms: in r0,PINA	;1
	in r3,PINC			;1
	st Y+,r0			;2
	st Y+,r3			;2
	mov XL,r16			;1
	mov XH,r17			;1
tlpra10ms_dly:
	ldi r18,98			;1
tlpra10ms_dly1: dec r18	;1
	brne tlpra10ms_dly1	;2/1
	rjmp PC+1			;2
	sbiw XH:XL,1		;2
	brne tlpra10ms_dly	;2/1
	ldi r18,96			;1
tlpra10ms_dly2: dec r18	;1
	brne tlpra10ms_dly2	;2/1
	nop
	sbiw r25:r24,1		;2
	brne tlpra10ms		;2
;						 300000
	rjmp trc_end

;20ms pre trigger, 600000 machine cycles
trc8_20ms_pr: ldi r16,LOW(1999)
	ldi r17,HIGH(1999)
	rjmp trc8_10ms_prc

trc16_20ms_pr: ldi r16,LOW(1999)
	ldi r17,HIGH(1999)
	rjmp trc16_10ms_prc

;50ms pre trigger, 1500000 machine cycles
trc8_50ms_pr: ldi r16,LOW(4999)
	ldi r17,HIGH(4999)
	rjmp trc8_10ms_prc

trc16_50ms_pr: ldi r16,LOW(4999)
	ldi r17,HIGH(4999)
	rjmp trc16_10ms_prc

;100ms pre trigger, 3000000 machine cycles
trc8_100ms_pr: ldi r16,LOW(9999)
	ldi r17,HIGH(9999)
	rjmp trc8_10ms_prc

trc16_100ms_pr: ldi r16,LOW(9999)
	ldi r17,HIGH(9999)
	rjmp trc16_10ms_prc

;200ms pre trigger, 6000000 machine cycles
trc8_200ms_pr: ldi r16,LOW(19999)
	ldi r17,HIGH(19999)
	rjmp trc8_10ms_prc

trc16_200ms_pr: ldi r16,LOW(19999)
	ldi r17,HIGH(19999)
	rjmp trc16_10ms_prc

;500ms pre trigger, 15000000 machine cycles
trc8_500ms_pr: ldi r16,LOW(49999)
	ldi r17,HIGH(49999)
	rjmp trc8_10ms_prc

trc16_500ms_pr: ldi r16,LOW(49999)
	ldi r17,HIGH(49999)
	rjmp trc16_10ms_prc

//trc_pre_end:


;0.5us post trigger
trc8_05us_po: rcall trc_prep
tlpo05us: in r0,PINA	;1	1
	st Y+,r0			;2	2
	and r0,r1			;1	1
	cp r0,r2			;1	1
	breq trc8_05us_stp	;1	1
	sbiw r25:r24,1		;2	2
	brne trc8_05us_po1	;1	2
	movw YH:YL,r21:r20	;1
	movw r25:r24,r23:r22 ;1
	rjmp PC+1			;2
	rjmp tlpo05us		;2
trc8_05us_po1: nop		;   1
	rjmp PC+1			;2
	rjmp tlpo05us		; 	2
;						 15 15
trc8_05us_stp: rjmp trc_post_end1

;0.5us post trigger
trc16_05us_po: rcall trc_prep
tlpoa05us: in r0,PINA	;1	1
	in r3,PINC			;1	1
	st Y+,r0			;2	2
	st Y+,r3			;2	2
	and r0,r1			;1	1
	cp r0,r2			;1	1
	breq trc16_05us_stp	;1	1
	sbiw r25:r24,1		;2	2
	brne trc16_05us_po1	;1	2
	movw YH:YL,r21:r20	;1
	movw r25:r24,r23:r22 ;1
	rjmp tlpoa05us		;2
trc16_05us_po1: rjmp tlpoa05us ; 	2
;						 15 15
trc16_05us_stp: rjmp trc_post_end1

;1us post trigger 30 cycles
trc8_1us_po: ldi r17,5
trc8_1us_poc: rcall trc_prep
tlpo1us: in r0,PINA		;1	1
	st Y+,r0			;2	2
	and r0,r1			;1	1
	cp r0,r2			;1	1
	breq trc8_1us_stp		;1	1
	sbiw r25:r24,1		;2	2
	brne trc8_1us_po1		;1	2
	movw YH:YL,r21:r20	;1
	movw r25:r24,r23:r22 ;1
	rjmp trc8_1us_po2		;2
trc8_1us_po1: nop			;   1
	rjmp PC+1			;	2
trc8_1us_po2: mov r16,r17 ;1
trc8_1us_dly:	dec r16
	brne trc8_1us_dly
	rjmp tlpo1us		; 	2
;						 15 15
trc8_1us_stp: rjmp trc_post_end1

;1us post trigger 30 cycles
trc16_1us_po: ldi r17,4
trc16_1us_poc: rcall trc_prep
tlpoa1us: in r0,PINA	;1	1
	in r3,PINC			;1	1
	st Y+,r0			;2	2
	st Y+,r3			;2	2
	and r0,r1			;1	1
	cp r0,r2			;1	1
	breq trc16_1us_stp	;1	1
	sbiw r25:r24,1		;2	2
	brne trc16_1us_po1	;1	2
	movw YH:YL,r21:r20	;1
	movw r25:r24,r23:r22 ;1
	rjmp trc16_1us_po2	;2
trc16_1us_po1: nop
	rjmp PC+1
trc16_1us_po2: mov r16,r17 ;1
trc16_1us_dly:	dec r16
	brne trc16_1us_dly
	rjmp tlpoa1us		; 	2
;						 15 15
trc16_1us_stp: rjmp trc_post_end1

;2us post trigger 60 cycles
trc8_2us_po: ldi r17,15
	rjmp trc8_1us_poc

trc16_2us_po: ldi r17,14
	rjmp trc16_1us_poc

;5us post trigger 150 cycles
trc8_5us_po: ldi r17,45
	rjmp trc8_1us_poc

trc16_5us_po: ldi r17,44
	rjmp trc16_1us_poc

;10us post trigger 300 cycles
trc8_10us_po: ldi r17,95
	rjmp trc8_1us_poc

trc16_10us_po: ldi r17,94
	rjmp trc16_1us_poc

;20us post trigger 600 cycles
trc8_20us_po: ldi r17,195
	rjmp trc8_1us_poc

trc16_20us_po: ldi r17,194
	rjmp trc16_1us_poc

;50us post trigger 1500 cycles
trc8_50us_po: ldi r16,LOW(371)
	ldi r17,HIGH(371)
trc8_50us_poc: rcall trc_prep
tlpo50us: in r0,PINA	;1	1
	st Y+,r0			;2	2
	and r0,r1			;1	1
	cp r0,r2			;1	1
	breq trc8_50us_stp	;1	1
	sbiw r25:r24,1		;2	2
	brne trc8_50us_po1	;1	2
	movw YH:YL,r21:r20	;1
	movw r25:r24,r23:r22 ;1
	rjmp trc8_50us_po2	;2
trc8_50us_po1: nop		;   1
	rjmp PC+1			;	2
trc8_50us_po2: mov XL,r16 ;1
	mov XH,r17			;1
trc8_50us_dly: sbiw XH:XL,1 ;2
	brne trc8_50us_dly		;2
	rjmp tlpo50us		; 	2
;						 15 15
trc8_50us_stp: rjmp trc_post_end1

;50us post trigger 1500 cycles
trc16_50us_po: ldi r16,LOW(370)
	ldi r17,HIGH(370)
trc16_50us_poc: rcall trc_prep
tlpoa50us: in r0,PINA	;1	1
	in r3,PINC			;1	1
	st Y+,r0			;2	2
	st Y+,r3			;2	2
	and r0,r1			;1	1
	cp r0,r2			;1	1
	breq trc16_50us_stp	;1	1
	nop
	sbiw r25:r24,1		;2	2
	brne trc16_50us_po1	;1	2
	movw YH:YL,r21:r20	;1
	movw r25:r24,r23:r22 ;1
	rjmp trc16_50us_po2	;2
trc16_50us_po1: nop		;   1
	rjmp PC+1			;	2
trc16_50us_po2: mov XL,r16 ;1
	mov XH,r17			;1
trc16_50us_dly: sbiw XH:XL,1 ;2
	brne trc16_50us_dly		;2
	rjmp tlpoa50us		; 	2
;						 15 15
trc16_50us_stp: rjmp trc_post_end1

;100us post trigger 3000 cycles
trc8_100us_po: ldi r16,LOW(746)
	ldi r17,HIGH(746)
	rjmp trc8_50us_poc

trc16_100us_po: ldi r16,LOW(745)
	ldi r17,HIGH(745)
	rjmp trc16_50us_poc

;200us post trigger 6000 cycles
trc8_200us_po: ldi r16,LOW(1496)
	ldi r17,HIGH(1496)
	rjmp trc8_50us_poc

trc16_200us_po: ldi r16,LOW(1495)
	ldi r17,HIGH(1495)
	rjmp trc16_50us_poc

;500us post trigger 15000 cycles
trc8_500us_po: ldi r16,LOW(3746)
	ldi r17,HIGH(3746)
	rjmp trc8_50us_poc

trc16_500us_po: ldi r16,LOW(3745)
	ldi r17,HIGH(3745)
	rjmp trc16_50us_poc

;1ms post trigger 30000 cycles
trc8_1ms_po: ldi r16,LOW(7496)
	ldi r17,HIGH(7496)
	rjmp trc8_50us_poc

trc16_1ms_po: ldi r16,LOW(7495)
	ldi r17,HIGH(7495)
	rjmp trc16_50us_poc

;2ms post trigger 60000 cycles
trc8_2ms_po: ldi r16,LOW(14996)
	ldi r17,HIGH(14996)
	rjmp trc8_50us_poc

trc16_2ms_po: ldi r16,LOW(14995)
	ldi r17,HIGH(14995)
	rjmp trc16_50us_poc

;5ms post trigger 150000 cycles
trc8_5ms_po: ldi r16,LOW(37496)
	ldi r17,HIGH(37496)
	rjmp trc8_50us_poc

trc16_5ms_po: ldi r16,LOW(37495)
	ldi r17,HIGH(37495)
	rjmp trc16_50us_poc

;10ms post trigger 300000 cycles
trc8_10ms_po: ldi r16,LOW(999)
	ldi r17,HIGH(999)
trc8_10ms_poc: rcall trc_prep
tlpo10ms: in r0,PINA	;1	1
	st Y+,r0			;2	2
	and r0,r1			;1	1
	cp r0,r2			;1	1
	breq trc8_10ms_stp	;1	1
	sbiw r25:r24,1		;2	2
	brne trc8_10ms_po1	;1	2
	movw YH:YL,r21:r20	;1
	movw r25:r24,r23:r22 ;1
	rjmp trc8_10ms_po2	;2
trc8_10ms_po1: nop		;   1
	rjmp PC+1			;	2
trc8_10ms_po2: mov XL,r16 ;1
	mov XH,r17			;1
trc8_10ms_dly: ldi r18,98
trc8_10ms_dly1: dec r18
	brne trc8_10ms_dly1
	rjmp PC+1			;2
	sbiw XH:XL,1		;2
	brne trc8_10ms_dly	;2
	ldi r18,94
trc8_10ms_dly2: dec r18
	brne trc8_10ms_dly2
	rjmp PC+1
	rjmp tlpo10ms		; 	2
;						 15 15
trc8_10ms_stp: rjmp trc_post_end1

;10ms post trigger 300000 cycles
trc16_10ms_po: ldi r16,LOW(999)
	ldi r17,HIGH(999)
trc16_10ms_poc: rcall trc_prep
tlpoa10ms: in r0,PINA	;1	1
	in r3,PINC			;1	1
	st Y+,r0			;2	2
	st Y+,r3			;2	2
	and r0,r1			;1	1
	cp r0,r2			;1	1
	breq trc16_10ms_stp	;1	1
	sbiw r25:r24,1		;2	2
	brne trc16_10ms_po1	;1	2
	movw YH:YL,r21:r20	;1
	movw r25:r24,r23:r22 ;1
	rjmp trc16_10ms_po2	;2
trc16_10ms_po1: nop		;   1
	rjmp PC+1			;	2
trc16_10ms_po2: mov XL,r16 ;1
	mov XH,r17			;1
trc16_10ms_dly: ldi r18,98
trc16_10ms_dly1: dec r18
	brne trc16_10ms_dly1
	rjmp PC+1
	sbiw XH:XL,1		;2
	brne trc16_10ms_dly	;2
	ldi r18,93
trc16_10ms_dly2: dec r18
	brne trc16_10ms_dly2
	rjmp PC+1
	rjmp tlpoa10ms		; 	2
;						 15 15
trc16_10ms_stp: rjmp trc_post_end1

;20ms post trigger 600000 cycles
trc8_20ms_po: ldi r16,LOW(1999)
	ldi r17,HIGH(1999)
	rjmp trc8_10ms_poc

trc16_20ms_po: ldi r16,LOW(1999)
	ldi r17,HIGH(1999)
	rjmp trc16_10ms_poc

;50ms post trigger, 1500000 machine cycles
trc8_50ms_po: ldi r16,LOW(4999)
	ldi r17,HIGH(4999)
	rjmp trc8_10ms_poc

trc16_50ms_po: ldi r16,LOW(4999)
	ldi r17,HIGH(4999)
	rjmp trc16_10ms_poc

;100ms post trigger, 3000000 machine cycles
trc8_100ms_po: ldi r16,LOW(9999)
	ldi r17,HIGH(9999)
	rjmp trc8_10ms_poc

trc16_100ms_po: ldi r16,LOW(9999)
	ldi r17,HIGH(9999)
	rjmp trc16_10ms_poc

;200ms post trigger, 6000000 machine cycles
trc8_200ms_po: ldi r16,LOW(19999)
	ldi r17,HIGH(19999)
	rjmp trc8_10ms_poc

trc16_200ms_po: ldi r16,LOW(19999)
	ldi r17,HIGH(19999)
	rjmp trc16_10ms_poc

;500ms post trigger, 15000000 machine cycles
trc8_500ms_po: ldi r16,LOW(49999)
	ldi r17,HIGH(49999)
	rjmp trc8_10ms_poc

trc16_500ms_po: ldi r16,LOW(49999)
	ldi r17,HIGH(49999)
	rjmp trc16_10ms_poc

// trc_post_end1:
