
binasc200use: rcall binasc_mpty
binasc200us: rcall binasc5xx
	rcall num_pref
	rcall binasc5
	rcall binasc_dot
binasc_dbl: add r0,r0
	rjmp binasc1

binasc25use: rcall binasc_mpty
binasc25us: ldi r16,5
	mul r0,r16
	rjmp binasc50us
binasc50use: rcall binasc_mpty
binasc50us: rcall binasc2000
	rcall num_pref
	rcall binasc2x1
	rcall binasc_dot
	rcall binasc2
binasc0or5:	ldi r16,$10
	tst r0
	breq binasc0or5x
	ldi r16,$15
binasc0or5x: rjmp get_digit1

binasc20use: rcall binasc_mpty
binasc20us: rcall binasc5000
	rcall num_pref
	rcall binasc5x1
	rcall binasc_dot
	rcall binasc5
	rjmp binasc_dbl

binasc40use: rcall binasc_mpty
binasc40us: ldi r16,4
	mul r0,r16
	rjmp binasc10us
binasc10use: rcall binasc_mpty
binasc10us: rcall binasc10000
	rcall num_pref
	rcall binasc10x1
	rcall binasc_dot
	rcall binasc10
	rjmp binasc1

binasc5use: rcall binasc_mpty
binasc5us: rcall binasc2xx
	rcall binasc2
	rcall num_pref
	rjmp binasc0or5

binasc2use: rcall binasc_mpty
binasc2us: rcall binasc5xx
	rcall binasc5
	rcall num_pref
	rjmp binasc_dbl

binasc1000use: ldi r16,10
	mul r0,r16
	rjmp binasc1use
binasc400use: ldi r16,4
	mul r0,r16
	rjmp binasc1use
binasc2us5: ldi r16,25
	mul r0,r16
binasc1use:	rcall binasc_mpty
binasc1us: rcall binasc10xx
	rcall binasc10
	rcall num_pref
	rjmp binasc1

binasc250us: ldi r16,5
	mul r0,r16
	rjmp binasc05us
binasc05use: rcall binasc_mpty
binasc05us: rcall binasc2xx
	rcall num_pref
	rcall binasc2
	rcall binasc_dot
	rjmp binasc0or5

binasc02us: rcall binasc5xx
	rcall num_pref
	rcall binasc5
	rcall binasc_dot
	rjmp binasc_dbl

binasc04us: ldi r16,4
	mul r0,r16
	rjmp binasc01usc
binasc01use: rcall binasc_mpty
	rjmp binasc01usc
binasc01us: sbic tr_mode,1
	rjmp binasc02us
binasc01usc: rcall binasc10xx
	rcall num_pref
	rcall binasc10
	rcall binasc_dot
binasc1: ldi r18,1
get_digit: ldi r16,$10
get_digitlp: sub r0,r18
	sbc r1,r19
	brcs get_digitx
	inc r16
	rcall num_pref
	rjmp get_digitlp
get_digitx: add r0,r18
	adc r1,r19
	brts get_digit1
	clr r16
get_digit1: rjmp lcd_chr

num_pref: brts num_prefx
	tst r17
	brne num_prefst
	sbis tr_mode,0
	rjmp num_prefst
	push r16
	ldi r16,'-'-32
	rcall lcd_chr
	pop r16
num_prefst: set
num_prefx: ret

binasc_prf: tst r17
	brne binasc_prfx
	sbis tr_mode,0
	rjmp binasc_prfx
 	ldi r18,LOW(trace_size)
	sbic tr_mode,1
	ldi r18,LOW(trace_size/2)
	ldi r19,HIGH(trace_size)
	sbic tr_mode,1
	ldi r19,HIGH(trace_size/2)
	sub r18,r0
	sbc r19,r1
	movw r1:r0,r19:r18
binasc_prfx: clt
	ret

binasc_mpty: clr r16
	rjmp lcd_chr

binasc_dot: ldi r16,'.'-32
	rjmp get_digit1

binasc2xx: rcall binasc2000
binasc2x1: ldi r18,20
binascxc: clr r19
	rjmp get_digit

binasc2000: rcall binasc_prf
	ldi r18,LOW(2000)
	ldi r19,HIGH(2000)
	rcall get_digit
	ldi r18,LOW(200)
	ldi r19,HIGH(200)
	rjmp get_digit

binasc2: ldi r18,2
	rjmp get_digit

binasc5xx: rcall binasc5000
binasc5x1: ldi r18,50
	rjmp binascxc

binasc5000: rcall binasc_prf
	ldi r18,LOW(5000)
	ldi r19,HIGH(5000)
	rcall get_digit
	ldi r18,LOW(500)
	ldi r19,HIGH(500)
	rjmp get_digit

binasc5: ldi r18,5
	rjmp get_digit

binasc10xx: rcall binasc10000
binasc10x1: ldi r18,100
	rjmp binascxc

binasc10000: rcall binasc_prf
	ldi r18,LOW(10000)
	ldi r19,HIGH(10000)
	rcall get_digit
	ldi r18,LOW(1000)
	ldi r19,HIGH(1000)
	rjmp get_digit

binasc10: ldi r18,10
	rjmp get_digit
